/**
 * 
 */
package com.sample;


import java.util.HashMap;
import java.util.Map;
import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.jbpm.process.workitem.wsht.HornetQHTWorkItemHandler;

import com.sample.leaveAppplication.workHandler.CheckAllocation;

import com.sample.leaveAppplication.workHandler.SendLeaveApplicationToPL;
import com.sample.leaveAppplication.workHandler.SendLeaveApplicationToTL;

/**
 * @author ind500
 *
 */
public class StartProcessFlow {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		KnowledgeBase kBase = readKnowledgeBase();
		StatefulKnowledgeSession ksession = kBase.newStatefulKnowledgeSession();
		
		ksession.getWorkItemManager().registerWorkItemHandler("checkAllocation",new CheckAllocation() );
		ksession.getWorkItemManager().registerWorkItemHandler("SendToPM",new SendLeaveApplicationToPL() );
		ksession.getWorkItemManager().registerWorkItemHandler("SendToTL",new SendLeaveApplicationToTL() );
//		ksession.getWorkItemManager().registerWorkItemHandler("validation", );
		HornetQHTWorkItemHandler humanTaskHandler = new HornetQHTWorkItemHandler(ksession);
		humanTaskHandler.setIpAddress("127.0.0.1");
		humanTaskHandler.setPort(5445);
//		humanTaskHandler.setClient(new HumanTaskPLService());
		ksession.getWorkItemManager().registerWorkItemHandler("Human Task", humanTaskHandler);
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("userName", "jay");
		params.put("leaveTotal",3);
		params.put("startDate", "07/20/2012");
		params.put("applyDate", "07/12/2012");
		ksession.startProcess("com.libapps.bpmn",params);


	}
	public static KnowledgeBase readKnowledgeBase()
	{
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("leaveApps.bpmn"), ResourceType.BPMN2);
		
		return kbuilder.newKnowledgeBase();
	}
}
